rebase --keep-empty: always use interactive rebase
[git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_STUCKLONG=t
9 OPTIONS_SPEC="\
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
11 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
12 git rebase --continue | --abort | --skip | --edit-todo
13 --
14  Available options are
15 v,verbose!         display a diffstat of what changed upstream
16 q,quiet!           be quiet. implies --no-stat
17 autostash          automatically stash/stash pop before and after
18 fork-point         use 'merge-base --fork-point' to refine upstream
19 onto=!             rebase onto given branch instead of upstream
20 p,preserve-merges! try to recreate merges instead of ignoring them
21 s,strategy=!       use the given merge strategy
22 no-ff!             cherry-pick all commits, even if unchanged
23 m,merge!           use merging strategies to rebase
24 i,interactive!     let the user edit the list of commits to rebase
25 x,exec=!           add exec lines after each commit of the editable list
26 k,keep-empty       preserve empty commits during rebase
27 f,force-rebase!    force rebase even if branch is up to date
28 X,strategy-option=! pass the argument through to the merge strategy
29 stat!              display a diffstat of what changed upstream
30 n,no-stat!         do not show diffstat of what changed upstream
31 verify             allow pre-rebase hook to run
32 rerere-autoupdate  allow rerere to update index with resolved conflicts
33 root!              rebase all reachable commits up to the root(s)
34 autosquash         move commits that begin with squash!/fixup! under -i
35 committer-date-is-author-date! passed to 'git am'
36 ignore-date!       passed to 'git am'
37 signoff            passed to 'git am'
38 whitespace=!       passed to 'git apply'
39 ignore-whitespace! passed to 'git apply'
40 C=!                passed to 'git apply'
41 S,gpg-sign?        GPG-sign commits
42  Actions:
43 continue!          continue
44 abort!             abort and check out the original branch
45 skip!              skip current patch and continue
46 edit-todo!         edit the todo list during an interactive rebase
47 quit!              abort but keep HEAD where it is
48 "
49 . git-sh-setup
50 set_reflog_action rebase
51 require_work_tree_exists
52 cd_to_toplevel
53
54 LF='
55 '
56 ok_to_skip_pre_rebase=
57 resolvemsg="
58 $(gettext 'Resolve all conflicts manually, mark them as resolved with
59 "git add/rm <conflicted_files>", then run "git rebase --continue".
60 You can instead skip this commit: run "git rebase --skip".
61 To abort and get back to the state before "git rebase", run "git rebase --abort".')
62 "
63 squash_onto=
64 unset onto
65 unset restrict_revision
66 cmd=
67 strategy=
68 strategy_opts=
69 do_merge=
70 merge_dir="$GIT_DIR"/rebase-merge
71 apply_dir="$GIT_DIR"/rebase-apply
72 verbose=
73 diffstat=
74 test "$(git config --bool rebase.stat)" = true && diffstat=t
75 autostash="$(git config --bool rebase.autostash || echo false)"
76 fork_point=auto
77 git_am_opt=
78 git_format_patch_opt=
79 rebase_root=
80 force_rebase=
81 allow_rerere_autoupdate=
82 # Non-empty if a rebase was in progress when 'git rebase' was invoked
83 in_progress=
84 # One of {am, merge, interactive}
85 type=
86 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
87 state_dir=
88 # One of {'', continue, skip, abort}, as parsed from command line
89 action=
90 preserve_merges=
91 autosquash=
92 keep_empty=
93 signoff=
94 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
95 case "$(git config --bool commit.gpgsign)" in
96 true)   gpg_sign_opt=-S ;;
97 *)      gpg_sign_opt= ;;
98 esac
99
100 read_basic_state () {
101         test -f "$state_dir/head-name" &&
102         test -f "$state_dir/onto" &&
103         head_name=$(cat "$state_dir"/head-name) &&
104         onto=$(cat "$state_dir"/onto) &&
105         # We always write to orig-head, but interactive rebase used to write to
106         # head. Fall back to reading from head to cover for the case that the
107         # user upgraded git with an ongoing interactive rebase.
108         if test -f "$state_dir"/orig-head
109         then
110                 orig_head=$(cat "$state_dir"/orig-head)
111         else
112                 orig_head=$(cat "$state_dir"/head)
113         fi &&
114         GIT_QUIET=$(cat "$state_dir"/quiet) &&
115         test -f "$state_dir"/verbose && verbose=t
116         test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
117         test -f "$state_dir"/strategy_opts &&
118                 strategy_opts="$(cat "$state_dir"/strategy_opts)"
119         test -f "$state_dir"/allow_rerere_autoupdate &&
120                 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
121         test -f "$state_dir"/gpg_sign_opt &&
122                 gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
123         test -f "$state_dir"/signoff && {
124                 signoff="$(cat "$state_dir"/signoff)"
125                 force_rebase=t
126         }
127 }
128
129 write_basic_state () {
130         echo "$head_name" > "$state_dir"/head-name &&
131         echo "$onto" > "$state_dir"/onto &&
132         echo "$orig_head" > "$state_dir"/orig-head &&
133         echo "$GIT_QUIET" > "$state_dir"/quiet &&
134         test t = "$verbose" && : > "$state_dir"/verbose
135         test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
136         test -n "$strategy_opts" && echo "$strategy_opts" > \
137                 "$state_dir"/strategy_opts
138         test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
139                 "$state_dir"/allow_rerere_autoupdate
140         test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
141         test -n "$signoff" && echo "$signoff" >"$state_dir"/signoff
142 }
143
144 output () {
145         case "$verbose" in
146         '')
147                 output=$("$@" 2>&1 )
148                 status=$?
149                 test $status != 0 && printf "%s\n" "$output"
150                 return $status
151                 ;;
152         *)
153                 "$@"
154                 ;;
155         esac
156 }
157
158 move_to_original_branch () {
159         case "$head_name" in
160         refs/*)
161                 message="rebase finished: $head_name onto $onto"
162                 git update-ref -m "$message" \
163                         $head_name $(git rev-parse HEAD) $orig_head &&
164                 git symbolic-ref \
165                         -m "rebase finished: returning to $head_name" \
166                         HEAD $head_name ||
167                 die "$(eval_gettext "Could not move back to \$head_name")"
168                 ;;
169         esac
170 }
171
172 apply_autostash () {
173         if test -f "$state_dir/autostash"
174         then
175                 stash_sha1=$(cat "$state_dir/autostash")
176                 if git stash apply $stash_sha1 >/dev/null 2>&1
177                 then
178                         echo "$(gettext 'Applied autostash.')" >&2
179                 else
180                         git stash store -m "autostash" -q $stash_sha1 ||
181                         die "$(eval_gettext "Cannot store \$stash_sha1")"
182                         gettext 'Applying autostash resulted in conflicts.
183 Your changes are safe in the stash.
184 You can run "git stash pop" or "git stash drop" at any time.
185 ' >&2
186                 fi
187         fi
188 }
189
190 finish_rebase () {
191         apply_autostash &&
192         { git gc --auto || true; } &&
193         rm -rf "$state_dir"
194 }
195
196 run_specific_rebase () {
197         if [ "$interactive_rebase" = implied ]; then
198                 GIT_EDITOR=:
199                 export GIT_EDITOR
200                 autosquash=
201         fi
202         . git-rebase--$type
203         ret=$?
204         if test $ret -eq 0
205         then
206                 finish_rebase
207         elif test $ret -eq 2 # special exit status for rebase -i
208         then
209                 apply_autostash &&
210                 rm -rf "$state_dir" &&
211                 die "Nothing to do"
212         fi
213         exit $ret
214 }
215
216 run_pre_rebase_hook () {
217         if test -z "$ok_to_skip_pre_rebase" &&
218            test -x "$(git rev-parse --git-path hooks/pre-rebase)"
219         then
220                 "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
221                 die "$(gettext "The pre-rebase hook refused to rebase.")"
222         fi
223 }
224
225 test -f "$apply_dir"/applying &&
226         die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
227
228 if test -d "$apply_dir"
229 then
230         type=am
231         state_dir="$apply_dir"
232 elif test -d "$merge_dir"
233 then
234         if test -f "$merge_dir"/interactive
235         then
236                 type=interactive
237                 interactive_rebase=explicit
238         else
239                 type=merge
240         fi
241         state_dir="$merge_dir"
242 fi
243 test -n "$type" && in_progress=t
244
245 total_argc=$#
246 while test $# != 0
247 do
248         case "$1" in
249         --no-verify)
250                 ok_to_skip_pre_rebase=yes
251                 ;;
252         --verify)
253                 ok_to_skip_pre_rebase=
254                 ;;
255         --continue|--skip|--abort|--quit|--edit-todo)
256                 test $total_argc -eq 2 || usage
257                 action=${1##--}
258                 ;;
259         --onto=*)
260                 onto="${1#--onto=}"
261                 ;;
262         --exec=*)
263                 cmd="${cmd}exec ${1#--exec=}${LF}"
264                 test -z "$interactive_rebase" && interactive_rebase=implied
265                 ;;
266         --interactive)
267                 interactive_rebase=explicit
268                 ;;
269         --keep-empty)
270                 keep_empty=yes
271                 ;;
272         --no-keep-empty)
273                 keep_empty=
274                 ;;
275         --preserve-merges)
276                 preserve_merges=t
277                 test -z "$interactive_rebase" && interactive_rebase=implied
278                 ;;
279         --autosquash)
280                 autosquash=t
281                 ;;
282         --no-autosquash)
283                 autosquash=
284                 ;;
285         --fork-point)
286                 fork_point=t
287                 ;;
288         --no-fork-point)
289                 fork_point=
290                 ;;
291         --merge)
292                 do_merge=t
293                 ;;
294         --strategy-option=*)
295                 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
296                 do_merge=t
297                 test -z "$strategy" && strategy=recursive
298                 ;;
299         --strategy=*)
300                 strategy="${1#--strategy=}"
301                 do_merge=t
302                 ;;
303         --no-stat)
304                 diffstat=
305                 ;;
306         --stat)
307                 diffstat=t
308                 ;;
309         --autostash)
310                 autostash=true
311                 ;;
312         --no-autostash)
313                 autostash=false
314                 ;;
315         --verbose)
316                 verbose=t
317                 diffstat=t
318                 GIT_QUIET=
319                 ;;
320         --quiet)
321                 GIT_QUIET=t
322                 git_am_opt="$git_am_opt -q"
323                 verbose=
324                 diffstat=
325                 ;;
326         --whitespace=*)
327                 git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
328                 case "${1#--whitespace=}" in
329                 fix|strip)
330                         force_rebase=t
331                         ;;
332                 esac
333                 ;;
334         --ignore-whitespace)
335                 git_am_opt="$git_am_opt $1"
336                 ;;
337         --signoff)
338                 signoff=--signoff
339                 ;;
340         --no-signoff)
341                 signoff=
342                 ;;
343         --committer-date-is-author-date|--ignore-date)
344                 git_am_opt="$git_am_opt $1"
345                 force_rebase=t
346                 ;;
347         -C*)
348                 git_am_opt="$git_am_opt $1"
349                 ;;
350         --root)
351                 rebase_root=t
352                 ;;
353         --force-rebase|--no-ff)
354                 force_rebase=t
355                 ;;
356         --rerere-autoupdate|--no-rerere-autoupdate)
357                 allow_rerere_autoupdate="$1"
358                 ;;
359         --gpg-sign)
360                 gpg_sign_opt=-S
361                 ;;
362         --gpg-sign=*)
363                 gpg_sign_opt="-S${1#--gpg-sign=}"
364                 ;;
365         --)
366                 shift
367                 break
368                 ;;
369         *)
370                 usage
371                 ;;
372         esac
373         shift
374 done
375 test $# -gt 2 && usage
376
377 if test -n "$action"
378 then
379         test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
380         # Only interactive rebase uses detailed reflog messages
381         if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
382         then
383                 GIT_REFLOG_ACTION="rebase -i ($action)"
384                 export GIT_REFLOG_ACTION
385         fi
386 fi
387
388 if test "$action" = "edit-todo" && test "$type" != "interactive"
389 then
390         die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
391 fi
392
393 case "$action" in
394 continue)
395         # Sanity check
396         git rev-parse --verify HEAD >/dev/null ||
397                 die "$(gettext "Cannot read HEAD")"
398         git update-index --ignore-submodules --refresh &&
399         git diff-files --quiet --ignore-submodules || {
400                 echo "$(gettext "You must edit all merge conflicts and then
401 mark them as resolved using git add")"
402                 exit 1
403         }
404         read_basic_state
405         run_specific_rebase
406         ;;
407 skip)
408         output git reset --hard HEAD || exit $?
409         read_basic_state
410         run_specific_rebase
411         ;;
412 abort)
413         git rerere clear
414         read_basic_state
415         case "$head_name" in
416         refs/*)
417                 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
418                 die "$(eval_gettext "Could not move back to \$head_name")"
419                 ;;
420         esac
421         output git reset --hard $orig_head
422         finish_rebase
423         exit
424         ;;
425 quit)
426         exec rm -rf "$state_dir"
427         ;;
428 edit-todo)
429         run_specific_rebase
430         ;;
431 esac
432
433 # Make sure no rebase is in progress
434 if test -n "$in_progress"
435 then
436         state_dir_base=${state_dir##*/}
437         cmd_live_rebase="git rebase (--continue | --abort | --skip)"
438         cmd_clear_stale_rebase="rm -fr \"$state_dir\""
439         die "
440 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
441 I wonder if you are in the middle of another rebase.  If that is the
442 case, please try
443         $cmd_live_rebase
444 If that is not the case, please
445         $cmd_clear_stale_rebase
446 and run me again.  I am stopping in case you still have something
447 valuable there.')"
448 fi
449
450 if test -n "$rebase_root" && test -z "$onto"
451 then
452         test -z "$interactive_rebase" && interactive_rebase=implied
453 fi
454
455 if test -n "$keep_empty"
456 then
457         test -z "$interactive_rebase" && interactive_rebase=implied
458 fi
459
460 if test -n "$interactive_rebase"
461 then
462         type=interactive
463         state_dir="$merge_dir"
464 elif test -n "$do_merge"
465 then
466         type=merge
467         state_dir="$merge_dir"
468 else
469         type=am
470         state_dir="$apply_dir"
471 fi
472
473 if test -t 2 && test -z "$GIT_QUIET"
474 then
475         git_format_patch_opt="$git_format_patch_opt --progress"
476 fi
477
478 if test -n "$signoff"
479 then
480         test -n "$preserve_merges" &&
481                 die "$(gettext "error: cannot combine '--signoff' with '--preserve-merges'")"
482         git_am_opt="$git_am_opt $signoff"
483         force_rebase=t
484 fi
485
486 if test -z "$rebase_root"
487 then
488         case "$#" in
489         0)
490                 if ! upstream_name=$(git rev-parse --symbolic-full-name \
491                         --verify -q @{upstream} 2>/dev/null)
492                 then
493                         . git-parse-remote
494                         error_on_missing_default_upstream "rebase" "rebase" \
495                                 "against" "git rebase $(gettext '<branch>')"
496                 fi
497
498                 test "$fork_point" = auto && fork_point=t
499                 ;;
500         *)      upstream_name="$1"
501                 if test "$upstream_name" = "-"
502                 then
503                         upstream_name="@{-1}"
504                 fi
505                 shift
506                 ;;
507         esac
508         upstream=$(peel_committish "${upstream_name}") ||
509         die "$(eval_gettext "invalid upstream '\$upstream_name'")"
510         upstream_arg="$upstream_name"
511 else
512         if test -z "$onto"
513         then
514                 empty_tree=$(git hash-object -t tree /dev/null)
515                 onto=$(git commit-tree $empty_tree </dev/null)
516                 squash_onto="$onto"
517         fi
518         unset upstream_name
519         unset upstream
520         test $# -gt 1 && usage
521         upstream_arg=--root
522 fi
523
524 # Make sure the branch to rebase onto is valid.
525 onto_name=${onto-"$upstream_name"}
526 case "$onto_name" in
527 *...*)
528         if      left=${onto_name%...*} right=${onto_name#*...} &&
529                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
530         then
531                 case "$onto" in
532                 ?*"$LF"?*)
533                         die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
534                         ;;
535                 '')
536                         die "$(eval_gettext "\$onto_name: there is no merge base")"
537                         ;;
538                 esac
539         else
540                 die "$(eval_gettext "\$onto_name: there is no merge base")"
541         fi
542         ;;
543 *)
544         onto=$(peel_committish "$onto_name") ||
545         die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
546         ;;
547 esac
548
549 # If the branch to rebase is given, that is the branch we will rebase
550 # $branch_name -- branch/commit being rebased, or HEAD (already detached)
551 # $orig_head -- commit object name of tip of the branch before rebasing
552 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
553 switch_to=
554 case "$#" in
555 1)
556         # Is it "rebase other $branchname" or "rebase other $commit"?
557         branch_name="$1"
558         switch_to="$1"
559
560         # Is it a local branch?
561         if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
562            orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
563         then
564                 head_name="refs/heads/$branch_name"
565         # If not is it a valid ref (branch or commit)?
566         elif orig_head=$(git rev-parse -q --verify "$branch_name")
567         then
568                 head_name="detached HEAD"
569
570         else
571                 die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
572         fi
573         ;;
574 0)
575         # Do not need to switch branches, we are already on it.
576         if branch_name=$(git symbolic-ref -q HEAD)
577         then
578                 head_name=$branch_name
579                 branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
580         else
581                 head_name="detached HEAD"
582                 branch_name=HEAD
583         fi
584         orig_head=$(git rev-parse --verify HEAD) || exit
585         ;;
586 *)
587         die "BUG: unexpected number of arguments left to parse"
588         ;;
589 esac
590
591 if test "$fork_point" = t
592 then
593         new_upstream=$(git merge-base --fork-point "$upstream_name" \
594                         "${switch_to:-HEAD}")
595         if test -n "$new_upstream"
596         then
597                 restrict_revision=$new_upstream
598         fi
599 fi
600
601 if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
602 then
603         stash_sha1=$(git stash create "autostash") ||
604         die "$(gettext 'Cannot autostash')"
605
606         mkdir -p "$state_dir" &&
607         echo $stash_sha1 >"$state_dir/autostash" &&
608         stash_abbrev=$(git rev-parse --short $stash_sha1) &&
609         echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
610         git reset --hard
611 fi
612
613 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
614
615 # Now we are rebasing commits $upstream..$orig_head (or with --root,
616 # everything leading up to $orig_head) on top of $onto
617
618 # Check if we are already based on $onto with linear history,
619 # but this should be done only when upstream and onto are the same
620 # and if this is not an interactive rebase.
621 mb=$(git merge-base "$onto" "$orig_head")
622 if test "$type" != interactive && test "$upstream" = "$onto" &&
623         test "$mb" = "$onto" && test -z "$restrict_revision" &&
624         # linear history?
625         ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
626 then
627         if test -z "$force_rebase"
628         then
629                 # Lazily switch to the target branch if needed...
630                 test -z "$switch_to" ||
631                 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
632                         git checkout -q "$switch_to" --
633                 if test "$branch_name" = "HEAD" &&
634                          ! git symbolic-ref -q HEAD
635                 then
636                         say "$(eval_gettext "HEAD is up to date.")"
637                 else
638                         say "$(eval_gettext "Current branch \$branch_name is up to date.")"
639                 fi
640                 finish_rebase
641                 exit 0
642         else
643                 if test "$branch_name" = "HEAD" &&
644                          ! git symbolic-ref -q HEAD
645                 then
646                         say "$(eval_gettext "HEAD is up to date, rebase forced.")"
647                 else
648                         say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
649                 fi
650         fi
651 fi
652
653 # If a hook exists, give it a chance to interrupt
654 run_pre_rebase_hook "$upstream_arg" "$@"
655
656 if test -n "$diffstat"
657 then
658         if test -n "$verbose"
659         then
660                 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
661         fi
662         # We want color (if set), but no pager
663         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
664 fi
665
666 test "$type" = interactive && run_specific_rebase
667
668 # Detach HEAD and reset the tree
669 say "$(gettext "First, rewinding head to replay your work on top of it...")"
670
671 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
672         git checkout -q "$onto^0" || die "could not detach HEAD"
673 git update-ref ORIG_HEAD $orig_head
674
675 # If the $onto is a proper descendant of the tip of the branch, then
676 # we just fast-forwarded.
677 if test "$mb" = "$orig_head"
678 then
679         say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
680         move_to_original_branch
681         finish_rebase
682         exit 0
683 fi
684
685 if test -n "$rebase_root"
686 then
687         revisions="$onto..$orig_head"
688 else
689         revisions="${restrict_revision-$upstream}..$orig_head"
690 fi
691
692 run_specific_rebase